import _extends from "@babel/runtime/helpers/esm/extends";
import genFontSizes from './genFontSizes';
import genRadius from './genRadius';
export default function genCommonMapToken(token) {
  var motionUnit = token.motionUnit,
    motionBase = token.motionBase,
    fontSizeBase = token.fontSizeBase,
    radiusBase = token.radiusBase,
    controlHeight = token.controlHeight,
    lineWidth = token.lineWidth;
  var fontSizes = genFontSizes(fontSizeBase);
  return _extends(_extends({
    // motion
    motionDurationFast: "".concat((motionBase + motionUnit).toFixed(1), "s"),
    motionDurationMid: "".concat((motionBase + motionUnit * 2).toFixed(1), "s"),
    motionDurationSlow: "".concat((motionBase + motionUnit * 3).toFixed(1), "s"),
    // font
    fontSizes: fontSizes.map(function (fs) {
      return fs.size;
    }),
    lineHeights: fontSizes.map(function (fs) {
      return fs.lineHeight;
    }),
    // line
    lineWidthBold: lineWidth + 1
  }, genRadius(radiusBase)), {
    // control
    controlHeightSM: controlHeight * 0.75,
    controlHeightXS: controlHeight * 0.5,
    controlHeightLG: controlHeight * 1.25
  });
}